package com.lifepay.pinpaddemo.activities.pinpad.firmware;

import android.view.View;
import android.widget.AdapterView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.lifepay.pinpaddemo.R;
import com.lifepay.pinpaddemo.activities.base.BaseFragment;
import com.lifepay.pinpaddemo.activities.pinpad.BluetoothDeviceAdapter;

import org.androidannotations.annotations.AfterViews;
import org.androidannotations.annotations.EFragment;
import org.androidannotations.annotations.UiThread;
import org.androidannotations.annotations.ViewById;

import java.util.ArrayList;
import java.util.List;

@EFragment(R.layout.f_qpos_loadfirmware_bluetooth_select)
public class FQPOSLoadFirmwareBluetoothSelect extends BaseFragment {

    protected String TAG = FQPOSLoadFirmwareBluetoothSelect.class.getSimpleName();

    @ViewById
    protected TextView tvTerminalsEmpty;
    @ViewById
    protected LinearLayout llTerminals;
    @ViewById
    protected ListView lvTerminals;

    BluetoothDeviceAdapter adapter;

    private FQPOSLoadFirmwareBluetoothSelectIntf intf;

    public void setIntf(FQPOSLoadFirmwareBluetoothSelectIntf intf) {
        this.intf = intf;
    }

    @AfterViews
    protected void init() {
        lvTerminals.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> adapterView,
                                    View view, int i, long l) {
                adapter.updateSelectedPosition(i);
                intf.select(i);
            }
        });

        adapter = new BluetoothDeviceAdapter(context, new ArrayList<String>());
        lvTerminals.setAdapter(adapter);
    }

    @UiThread
    public void updateDevicesList(List<String> devices) {
        if(tvTerminalsEmpty ==null)
            return;

        if (devices.size() > 0) {
            adapter.clear();
            for (String str : devices) {
                adapter.insert(str, adapter.getCount());
            }
            adapter.setDeviceNames(devices);
            adapter.notifyDataSetChanged();

            tvTerminalsEmpty.setVisibility(View.GONE);
            llTerminals.setVisibility(View.VISIBLE);
        } else {
            tvTerminalsEmpty.setVisibility(View.VISIBLE);
            llTerminals.setVisibility(View.GONE);
        }
    }

    @Override
    public void onResume() {
        super.onResume();
        if (intf != null && this.getView() != null
                && this.getView().getVisibility() == View.GONE) intf.update();
    }

    public interface FQPOSLoadFirmwareBluetoothSelectIntf {
        void select(int index);
        void update();
    }
}